#!/usr/bin/env python
# getServerInfo to make sure DBS instances is avtive or not.
# Author: Liang dong
# <dbs>
# 	<instance id="d1" name="prod_global" type="reader" machine="cmsdbs1" checktime="" duration="" active="true" downtime="" server="" schema=""/> 
# </dbs>
import sys
import time
from xml.dom.minidom import parse
import math
#from dbsApi import DbsApi
from DBSAPI.dbsException import *
from DBSAPI.dbsApiException import *
from DBSAPI.dbsOptions import DbsOptionParser
from DBSAPI.dbsApi import DbsApi
import threading,os
class DBSActive(threading.Thread):
	"check DBS instances are active or not implement threading"
	def __init__(self):
		self.appdir = os.getenv('APP_DIR')
		self.prefix_r     = "http://"
		self.prefix_w     = "https://"
		self.prefix_a     = "https://"
		self.middle_r     = ".cern.ch/"
		self.middle_w     = ".cern.ch:8443/"
		self.middle_a     = ".cern.ch:8443/"
		self.url_suffix_r = "/servlet/DBSServlet"
		self.url_suffix_w = "_writer/servlet/DBSServlet"
		self.url_suffix_a = "_admin/servlet/DBSServlet"

		self.instancelist = [
			"cms_dbs_prod_global",
			"cms_dbs_prod_local_01",
			"cms_dbs_prod_local_02",
			"cms_dbs_prod_local_03",
			"cms_dbs_prod_local_04",
			"cms_dbs_prod_local_05",
			"cms_dbs_prod_local_06",
			"cms_dbs_prod_local_07",
			"cms_dbs_prod_local_08",
			"cms_dbs_prod_local_09",
			"cms_dbs_prod_local_10",
			"cms_dbs_ph_analysis_01",
			"cms_dbs_ph_analysis_02",
			"cms_dbs_caf_analysis_01",
			"cms_dbs_prod_tier0",
			"cms_dbs_int_tier0"
		]
			#,"cms_dbs_int_global"]
		self.type=['reader','writer','admin']
		threading.Thread.__init__(self)

	def getserverlist(self):
		serverlist=[]
		for instance_name in self.instancelist:
			if(instance_name != "cms_dbs_prod_tier0" and instance_name != "cms_dbs_int_tier0"):
				serverlist.append("%s%s%s%s%s"%(self.prefix_r,"cmsdbs1",self.middle_r,instance_name,self.url_suffix_r))
				serverlist.append("%s%s%s%s%s"%(self.prefix_w,"cmsdbs1",self.middle_w,instance_name,self.url_suffix_w))
				serverlist.append("%s%s%s%s%s"%(self.prefix_a,"cmsdbs1",self.middle_a,instance_name,self.url_suffix_a))
				serverlist.append("%s%s%s%s%s"%(self.prefix_r,"cmsdbs2",self.middle_r,instance_name,self.url_suffix_r))
				serverlist.append("%s%s%s%s%s"%(self.prefix_w,"cmsdbs2",self.middle_w,instance_name,self.url_suffix_w))
				serverlist.append("%s%s%s%s%s"%(self.prefix_a,"cmsdbs2",self.middle_a,instance_name,self.url_suffix_a))
			else :
				serverlist.append("%s%s%s%s%s"%(self.prefix_r,"cmst0dbs1",self.middle_r,instance_name,self.url_suffix_r))
				serverlist.append("%s%s%s%s%s"%(self.prefix_w,"cmst0dbs1",self.middle_w,instance_name,self.url_suffix_w))
				serverlist.append("%s%s%s%s%s"%(self.prefix_a,"cmst0dbs1",self.middle_a,instance_name,self.url_suffix_a))
				serverlist.append("%s%s%s%s%s"%(self.prefix_r,"cmst0dbs2",self.middle_r,instance_name,self.url_suffix_r))
				serverlist.append("%s%s%s%s%s"%(self.prefix_w,"cmst0dbs2",self.middle_w,instance_name,self.url_suffix_w))
				serverlist.append("%s%s%s%s%s"%(self.prefix_a,"cmst0dbs2",self.middle_a,instance_name,self.url_suffix_a))
		return serverlist
	
	def modifyXML(self,index,instances_xml,active,checktime,downtime,duration):
		i = int(math.floor(index / 6))
	#	print i
		instances_xml[index].setAttribute("name",self.instancelist[i])
		i2 = int(math.floor(index / 3))
	#	print i2
		if(i2 <= 26):
			if(i2%2==0):
				instances_xml[index].setAttribute("machine","cmsdbs1")
			else :
				instances_xml[index].setAttribute("machine","cmsdbs2")
		else :
			if(i2%2==0):
				instances_xml[index].setAttribute("machine","cmst0dbs1")
			else : 
				instances_xml[index].setAttribute("machine","cmst0dbs2")
		instances_xml[index].setAttribute("type",self.type[index%3])
		instances_xml[index].setAttribute("active",active)
		instances_xml[index].setAttribute("checktime",checktime)
		instances_xml[index].setAttribute("duration",duration)
		instances_xml[index].setAttribute("downtime",downtime)
	def outputXML(self,xmldoc):
		filename = os.path.join(self.appdir,'dbs.xml')
		output = open(filename,'w')
		output.write(xmldoc.toxml())
		output.close()
 
	def run(self):
		templatefilename = os.path.join(self.appdir,"template_dbs.xml")
		hisfilename = os.path.join(self.appdir,"dbs.xml")
		while 1:
			try:
				optManager  = DbsOptionParser()
				(opts,args) = optManager.getOpt()
			except DbsApiException, ex:
				pass
				print "Caught API Exception %s: %s "  % (ex.getClassName(), ex.getErrorMessage() )
				if ex.getErrorCode() not in (None, ""):
					print "DBS Exception Error Code: ", ex.getErrorCode()
		
			# get XML template get history XML
			xmldoc = parse(templatefilename)
			xmlhis = parse(hisfilename)
			instances_xml=xmldoc.getElementsByTagName("instance")
			inhis_xml = xmlhis.getElementsByTagName("instance")
	
			queryStart = time.localtime()
			checkTime = "%s"% time.strftime("%m/%d/%y %H:%M:%S %Z", queryStart)
			xml_index = 0
			serverlist = self.getserverlist()
			for url in serverlist:
	
				opts.__dict__['url']=url
				api = DbsApi(opts.__dict__)
				t1 = time.time()
				try:
					serverInfo = api.getServerInfo()
				except DbsApiException, ex:
					if inhis_xml[xml_index].getAttribute('active') == "True":
						self.modifyXML(xml_index,instances_xml,'false',checkTime,checkTime,"")
					else : self.modifyXML(xml_index,instances_xml,'false',checkTime,inhis_xml[xml_index].getAttribute('downtime'),"")
					xml_index += 1
					continue
					print "Caught API Exception %s: %s "  % (ex.getClassName(), ex.getErrorMessage() )
					if ex.getErrorCode() not in (None, ""):
						print "DBS Exception Error Code: ", ex.getErrorCode()
				t2 = time.time()
				duration=(t2-t1)
				duration = "%.3f"%duration
				self.modifyXML(xml_index,instances_xml,'true',checkTime,"",duration)
			#		print "%s\t Server : %s\tSchema : %s"%(self.instancelist[index], serverInfo['ServerVersion'], serverInfo['SchemaVersion'])
				xml_index +=1
			self.outputXML(xmldoc)
			time.sleep(15*60)
if __name__ == '__main__':
        thread = DBSActive()
        thread.start()



