#!/usr/bin/env python
# Borrow idea from fnget.py 
# Thanks Sinisa Lee Dave
# Author: Liang dong
# <frontier> 
#	<instance id="f1" name="FrontierProd" machine="cmsfrontier1" checktime=" " duration="" active="true" downtime="" />
# </frontier> 
import sys
import urllib2
from xml.dom.minidom import parseString
from xml.dom.minidom import parse
import base64
import zlib
import string
import curses.ascii
import time
import threading,os
#import os.path
class FrontierActive(threading.Thread):
	"check Frontier instances are active or not implement threading"
	def __init__(self):
		self.appdir = os.getenv('APP_DIR')
		self.prefix_list = ("http://cmsfrontier1.cern.ch:8000/","http://cmsfrontier2.cern.ch:8000/","http://cmsfrontier3.cern.ch:8000/")
		self.suffix = "/Frontier"
		self.instances = ('FrontierProd','Frontier','PromptProd','FrontierPrep','FrontierInt')#FrontierDev
#		self.servers=('cmsfrontier1','cmsfrontier2','cmsfrontier3')
#		self.frontierUrl = None
		self.frontierQuery = 'select 1 from dual' 
		self.url_list = []
#		self.frontierRequest = ""
		self.frontierId = "FrontierActive_forweb_101.py"
		self.expectation_data = "     1     NUMBER"
		self.encQuery = ""	
		threading.Thread.__init__(self)

	def getUrl(self,instance):
		temp = "%s%s"%(instance,self.suffix)
		return "%s%s"%(self.prefix_list[0],temp),"%s%s"%(self.prefix_list[1],temp),"%s%s"%(self.prefix_list[2],temp)

	def getRequest(self,frontierUrl):
		return "%s?type=frontier_request:1:DEFAULT&encoding=BLOB&p1=%s" % (frontierUrl, self.encQuery)
	def modifyXML(self,instances_xml,index,active,checktime,downtime,duration):
		instances_xml[index].setAttribute("active",active)
		instances_xml[index].setAttribute("checktime",checktime)
		instances_xml[index].setAttribute("duration",duration)
		instances_xml[index].setAttribute("downtime",downtime)
	def outputXML(self,xmldoc):
		filename = os.path.join(self.appdir,'frontier.xml')
		output = open(filename,'w')
		output.write(xmldoc.toxml())
		output.close()
		#print "output closed"
	def run(self):
		templatefilename = os.path.join(self.appdir,'template_frontier.xml')	
		hisfilename = os.path.join(self.appdir,'frontier.xml')
		while 1:
			# get XML template
			xmldoc = parse(templatefilename)
			xmlhis = parse(hisfilename)
			instances_xml=xmldoc.getElementsByTagName("instance")
			inhis_xml = xmlhis.getElementsByTagName("instance")
			# encode query
			self.encQuery = base64.binascii.b2a_base64(zlib.compress(self.frontierQuery,9)).replace("+", ".")
			queryStart = time.localtime()
			#print "Check time : ", time.strftime("%m/%d/%y %H:%M:%S %Z", queryStart)
			checkTime = "%s"% time.strftime("%m/%d/%y %H:%M:%S %Z", queryStart)
			self.url_list = map(self.getUrl,self.instances)				
			index_instance =0
			index_server =0
			for instance_url in self.url_list:
				request_list = map(self.getRequest,instance_url)
				for frontierRequest in request_list:
					index_server +=1     # 
					xml_index = index_instance*3 + index_server-1
					request = urllib2.Request(frontierRequest)
					request.add_header("X-Frontier-Id", self.frontierId)
					t1 = time.time()
					try:
						result = urllib2.urlopen(request).read()
					except : 
						#print "%s\tcmsfrontier%d\tactive...<Failed>"%(instances[index_instance],index_server)
						#print"HTTP Connect Exception: "
						if inhis_xml[xml_index].getAttribute('active') == "true": 
							self.modifyXML(instances_xml,xml_index,'false',checkTime,checkTime,"")
						else : self.modifyXML(instances_xml,xml_index,'false',checkTime,inhis_xml[xml_index].getAttribute('downtime'),"")
						continue
					t2 = time.time()
					duration=(t2-t1) #
					duration = "%.3f"%duration
					dom = parseString(result)
					if(dom.getElementsByTagName("data") == []): 
						#print "%s\tcmsfrontier%d\tactive...<Failed>"%(instances[index_instance],index_server)
						#print result
						if inhis_xml[xml_index].getAttribute('active') == "true":
							self.modifyXML(instances_xml,xml_index,'false',checkTime,checkTime,duration)
						else : self.modifyXML(instances_xml,xml_index,'false',checkTime,inhis_xml[xml_index].getAttribute('downtime'),duration)
			#			if dom.getElementsByTagName("payload")[0].childNodes[1] != None :
			#				print "Error message: %s"%dom.getElementsByTagName("payload")[0].childNodes[1].getAttribute("message")
						#print dir(dom.getElementsByTagName("payload")[0].childNodes[1].getAttribute("message"))
	
						continue
					data = dom.getElementsByTagName("data")[0]
					if data.firstChild is not None:
						row = base64.decodestring(data.firstChild.data)
						for c in [ '\x00', '\x01', '\x02', '\x03', '\x04', '\x05', '\x06', '\x08', '\x09', '\x0a', '\x0b', '\x0c', '\x0d', '\x1b', '\x17'  ]:
							row = row.replace(c, ' ')
						endFirstRow = row.find('\x07')
						firstRow = row[:endFirstRow]
						for c in firstRow:
							if curses.ascii.isctrl(c):
								firstRow = firstRow.replace(c, '\n')
						if firstRow==self.expectation_data: 
		#					print "%s\tcmsfrontier%d\tresponding in %.3f seconds.<OK>"%(instances[index_instance],index_server,duration)
							self.modifyXML(instances_xml,xml_index,'true',checkTime,"",duration)
						else:
		#					print "%s\tcmsfrontier%d\tactive...<Failed>"%(instances[index_instance],index_server)
							if inhis_xml[xml_index].getAttribute('active') == "true":
								self.modifyXML(instances_xml,xml_index,'false',checkTime,checkTime,duration)
							else : self.modifyXML(instances_xml,xml_index,'false',checkTime,inhis_xml[xml_index].getAttribute('downtime'),duration)
					else:
			#			print "%s\tcmsfrontier%d\tactive...<Failed>"%(instances[index_instance],index_server)
							if inhis_xml[xml_index].getAttribute('active') == "true":
								self.modifyXML(instances_xml,xml_index,'false',checkTime,checkTime,duration)
							else : self.modifyXML(instances_xml,xml_index,'false',checkTime,inhis_xml[xml_index].getAttribute('downtime'),duration)
				index_instance +=1		
				index_server=0
			
			self.outputXML(xmldoc)
			time.sleep(15*60)
if __name__ == '__main__':
	thread = FrontierActive()
	thread.start()

