#!/usr/bin/python
import re
import os
import string
import time
class FrontierLogParse :
	"""The common logfile format is as follows:
		connect_ip rfc931 connect_dn [date] "request" http_status bytes "squid_status" "resp_size" "user_info"
		dict  : first parse get 10 items
		dict_request : request item parse get 4 items
		dict_time : date item parse get 7 items
		dict_params : param item parse get changable items
		dict_result : def parse use to return values 
	"""
	dict = ('connect_ip','loginname','connect_dn','date','request','http_status','bytes','squid_status','resp_size','user_info')
	dict_request = ('connect_type','instance','param','reqpro')
#	dict_time = ('day','month','year','hour','minute','second','adj')
#	dict_params = ('instance','api','apiversion')
	node_lookup={}
	#should be adaptive adjust
#	dict_result={	"connect_ip":"",	"nodename":"",	"domain":"",	"time":"",	"return_size":"",	"user_info":"",	"instance":"",	"api":"",	"apiversion":"",	"connect_type":"",	"connect_dn":""	}
	tuple_result = ('connect_ip','nodename','domain','time','return_size','user_info','instance','api','apiversion','connect_type','connect_dn')
	list_result = []
	begint = -1
	endt = 10000000000
	instance_rate_dict={}
	instance_chose = ''
	last_time = 0
	
	def __init__(self):
		""" all re pattern init here:
			pline    : parse log line      => dict
			prequest : parse request item  =>dict_request
			ptime    : parse date    item  =>dict_time   
			format   : change 16bit in param item 
		"""		
		self.pline = re.compile(r"""
			(?P<connect_ip>\d+\.\d+\.\d+\.\d+)   # d.d.d.d
			\s(\"(?P<loginname>[^\"]+)\"|-)      # - 	
			\s(\"(?P<connect_dn>[^\"]+)\"|-)     # "/DC=x/OU=x y/DN=x y"
			\s(\[(?P<date>[^\]]+)\]|-)           # [d/M/y/h/m/s +tz]
			\s(\"(?P<request>[^\"]+)\")          # 
			\s(?P<http_status>\d+)               # 200/500/..
			\s(?P<bytes>\d+)                     # d
			\s((?P<squid_status>[^\s]+)|-)  # "-"
			\s((?P<resp_size>\d+)|-)        # Jave/..
			\s(\"(?P<user_info>[^\"]+)|"-")           # d
			""",re.VERBOSE)
		self.prequest = re.compile(r"""
			(?P<connect_type>(GET|POST))
			\shttp\:\/\/[^\/]+
			\/(?P<instance>[^\/]+)
			\/([^?\s]+)(|\?(?P<param>[^\s]+))
			\s(?P<reqpro>.+)$
			""",re.VERBOSE)
		self.pcernip  = re.compile(r"""(128\.142|137\.138)
		""",re.VERBOSE)
		self.pt0ip = re.compile(r"""128\.142\.17(4\.19|4\.76|5\.139|5\.140)
		""",re.VERBOSE)
	
	def parseline(self,line):
		""" log line => small item 
			m.group(p) 10 items
			mr.group(p) request 4 items
			mt.group(p) date 7 items
			params format =>split => store in dict_result
		"""
		top =  self.pline.search(line)
		if top !=None: topdict = top.groupdict()
		else: 
			return []
# request
		if topdict.has_key('request'):
			request = self.prequest.search(topdict.get('request'))
			if request !=None: 
				requestdict = request.groupdict()
			else: return []
		else: 
			return []
# user_info
		cmssw_info = "unknown"
		user_name = "unkown"
		if topdict.has_key('user_info'):
			user_info = string.split(topdict.get('user_info')," ");
			cmssw_info = " ".join(user_info[0:2]);
			user_name = " ".join(user_info[3:]);
		else:
			return []
		connect_ip = "unknown"
#		connect_domain = "unknown"
#		connect_nodename = "unknown"

			
		if topdict.has_key('connect_ip'):
			connect_ip = topdict.get('connect_ip')
#			cernip = self.pcernip.match(connect_ip)
			t0ip   = self.pt0ip.match(connect_ip)
#		skip non cernip and t0ip
#			if cernip == None:return []  
#			if t0ip !=None : return []
			if t0ip ==None : return []
		try:
#			reuse the ip information	
			if self.node_lookup.has_key(connect_ip):
				connect_node = self.node_lookup[connect_ip]
			else:
				connect_node = os.popen("dig -x %s +short"%connect_ip ).readline().replace(".\n","")	
				self.node_lookup[connect_ip] = connect_node
#			if connect_node != "" :
#				part = string.split(connect_node,".")
#				connect_domain = connect_node.replace(part[0]+".","")
#    			connect_nodename = part[0]
		except:
			print "can't find hostname";
			pass

#		return_size   = topdict.get('bytes')
		instance        = requestdict.get('instance')
		squid_status    = topdict.get('squid_status')
#		connect_type    = requestdict.get('connect_type')
#		connect_dn      = topdict.get('connect_dn')
		
		#TODO add instance_rate count process  here
#		if self.instance_chose =='':
#			pass
#		elif cmp(self.instance_chose,'all')==0:
#			self.instance_rate_increase(requestdict.get('instance'))
#		elif cmp(self.instance_chose,requestdict.get('instance'))==0:
#			self.instance_rate_increase(self.instance_chose)		
		self.list_result=[connect_node,instance,squid_status,cmssw_info+" "+user_name]
#		self.list_result=[connect_ip,instance,squid_status,cmssw_info,user_name]
#		self.view(topdict,requestdict)	
		return self.list_result

	def ParamsOutput(self,filename="/data/squid_logs/access.log"):
		""" Parse log
		"""
#		print (filename)
#		outfile = "".join((filename,".par"))
		#print outfile
		dict_output        = []
		num_output         = []
		dict_user		   = []
		num_user	       = []
		output_user        = []
		output_user_num	   = []
		dict_connect_node  = []
		num_connect_node   = []
		dict_instance      = [] 
		num_instance	   = []
#		dict_squid_status  = []
#		num_squid_status   = []
		
#		print "execute something here \n"
		try:
			input = open(filename,"rb")
		except IOError:
			print "open error \n"
			return 0	
#			output = open(outfile,"w")
#		try:
		line = input.readline()
#		finally:
#			input.close()
#			output.close()	
#			return 0
#		count =0
		while(line):
#			count = count+1
			oline = self.parseline(line)
# 			[connect_nodename,instance,squid_status,cmssw_info,user_name]
#                 dict_output       = [dict_user1,..]
#			dict_user         = [dict_connect_node,dict_instance]
#			dict_connect_node = [node1,..]
#			dict_instance     = [instance1,..]
#			out_user		  = [username1,..]
#			output.write(" ".join(oline.values()))			
			line = input.readline()
			line = line.rstrip()
			index_temp = 0;
			if oline == []:
				continue
#			check out user_num
			if(output_user.count(oline[3]) == 0):
				output_user.append(oline[3])
				output_user_num.append(1)
				dict_user = [[],[]]	
				num_user = [[],[]]	
				dict_output.append(dict_user)				
				num_output.append(num_user)				
			else:
				index_temp = output_user.index(oline[3])	
				output_user_num[index_temp] += 1
				dict_user = dict_output[index_temp]
				num_user = num_output[index_temp]

			dict_connect_node = dict_user[0]
			dict_instance	  = dict_user[1]
			num_connect_node  = num_user[0]
			num_instance      = num_user[1]
#			check out connect node number
			if(dict_connect_node.count(oline[0]) == 0):
				dict_connect_node.append(oline[0])
				num_connect_node.append(1)
			else:
				num_connect_node[dict_connect_node.index(oline[0])] +=1
#			check out the instance number
			if(dict_instance.count(oline[1]) == 0):
				dict_instance.append(oline[1])
				num_instance.append(1)
			else:
				num_instance[dict_instance.index(oline[1])] +=1
#			output.write(" ".join(oline))
#			output.write('\n')
#			print " ".join(oline)+"\n"
		user_count = 0
		for user in output_user:
			if output_user_num[user_count]<200:	
				user_count +=1
				continue
			print output_user_num[user_count]," ",user
			node_count = 0 
			for node in dict_output[user_count][0]:
#				if num_output[user_count][0][node_count]<300:	continue
				print "\t",num_output[user_count][0][node_count]," ",node
				node_count +=1
				instance_count = 0
			for instance in dict_output[user_count][1]:
#				if num_output[user_count][1][instance_count]<300: continue
				print "\t",num_output[user_count][1][instance_count]," ",instance			
				instance_count +=1
			user_count +=1

		input.close()

if __name__ == '__main__':
	test = FrontierLogParse()						
	#teststr="""137.138.5.226 - - [06/Nov/2008:23:25:50 +0000] "GET http://127.0.0.1:8080/Frontier/Frontier?type=frontier_request:1:DEFAULT&encoding=BLOBzip&p1=eNorTs1JTS5RsLS0VEgrys9VSClNzAEASFYG5g== HTTP/1.0" 200 740 TCP_MEM_HIT:NONE 0 "-" """	
	
	#test.set_begintime("2008-09-24-08-08-08")
	#test.set_endtime("2008-09-24-16-08-08")
	#print test.parseline(teststr)
	test.ParamsOutput();
