var instances= new Object();
/** singleton Frontier  */
instances.Frontier=function(){
  this.instances=new Array();
  this.objViewSpec=[
    {name:"instances",type:"array"}
  ];
  this.instances.objViewSpec=new Array();
}

/** render the Frontier */
instances.Frontier.prototype.render=function(table){
  this.mainTable=xGetElementById(table);
  for (var p in this.instances){
    var pl=this.instances[p];
    if (pl.render){
      //logger.append(pl.id+" in Frontier.render");
      var td = xGetElementById(pl.id);
      //logger.append(td.toString()+td.getAttribute("id"));
      pl.render(td);
    }
  }
}

/** add a instance to the Frontier system */
instances.Frontier.prototype.addInstance=function(instance){
  if (instance && instance.id){
    this.instances[instance.id]=instance;
    this.instances.objViewSpec.append( {name:instance.id,type:"object",inline:true} );
  }
}
instances.Frontier.prototype.removeInstance=function(instance){
  if (instance && instance.id){
    this.instances[instance.id]=null;
    var spec=this.instances.objViewSpec;
    for(var i=0;i<spec.length;i++){
      var child=spec[i];
      if (child.name==instance.id){
        spec.removeAt(i);
      }
    }
  }
}

instances.frontier=new instances.Frontier();
instances.Frontier=null;
Active_YES_IMG = "resources/img/active_yes.png";
Active_NO_IMG = "resources/img/active_no.png";

/** */
instances.Instance=function(id,system,name,machine,active,checktime,downtime,duration){
  this.id=id;
  this.system=system;
  this.machine=machine;
  this.name=name;
  this.active=active;
  this.checktime=checktime;
  this.downtime=downtime;
  this.duration=duration;
  this.objViewSpec=[
    {name:"name",     type:"simple"},
    {name:"machine", type:"simple"},    
    {name:"checktime", type:"simple"},
    {name:"active",    type:"simple"},
	{name:"downtime",    type:"simple"},
	{name:"duration",    type:"simple"}
  ];
      
}
instances.Instance.prototype.refreshValue=function(id,system,name,machine,active,checktime,downtime,duration){
	//logger.append("refresh instanceObj "+name);
  this.id=id;
  this.system=system;
  this.machine=machine;
  this.name=name;
  this.active=active;
  this.checktime=checktime;
  this.downtime=downtime;
  this.duration=duration;
}
/** render the button for this instance in the host frontier system's main div */
instances.Instance.prototype.render=function(td){
  if (!this.mainTable){
    //don't render if the host frontier system hasn't
    if (this.system.mainTable){
      //var div=document.getElementById(this.id);
      var active_item = td.childNodes[0];
      if (!active_item){      	
        active_item=document.createElement("img");   
        active_item.setAttribute("id","img");     
        
        if(this.active == "true"){    
        	//logger.append(this.active+"active true"+this.id);    	
        	active_item.src=Active_YES_IMG;
        	active_item.alt="Active";
        }else {
        	//logger.append("active falsse");
        	active_item.src=Active_NO_IMG;
        	active_item.alt="Down";
        } 
        
		td.appendChild(active_item);         
        td.onmousemove=instances.Instance.Popup;
        td.onmouseout = instances.Instance.Hide;
        td.instanceModel=this;
      }else{
      	
      	if(this.active == "true"){    
        	//logger.append(this.active+"active true"+this.id);    	
        	active_item.src=Active_YES_IMG;
        	active_item.alt="Active";
        }else {
        	//logger.append("active falsse");
        	active_item.src=Active_NO_IMG;
        	active_item.alt="Down";
        } 
      }
     //this.mainTable=td;
    }
  }
}

instances.Instance.Popup=function(event){
  var instance=this.instanceModel;
  //if (instances.Instance.activeMenu){
    //instances.Instance.activeMenu.hide();
  //}
  //logger.append("check before Popup"+instance.name);
  instances.Instance.activeMenu=objviewer.PropertyViewer.showPopup(this,instance,false);
}

instances.Instance.Hide=function(event){
	var instance=this.instanceModel;
	instances.Instance.activeMenu.hide();
}

/** parse a planet object from the xml returned by server, creating a new object or
updating the existing one as necessary 
* id,system,name,machine,active,checktime,downtime,duration*/
instances.Instance.parse=function(domEl){

  var sys=instances.frontier;
  var attrs=domEl.attributes;
  var id=attrs.getNamedItem("id").value;
  var name=attrs.getNamedItem("name").value;
  var active=attrs.getNamedItem("active").value;
  var checktime=attrs.getNamedItem("checktime").value;
  var duration=attrs.getNamedItem("duration").value;
  var machine=attrs.getNamedItem("machine").value;
  var downtime=attrs.getNamedItem("downtime").value;
  //logger.append(id+" in parse ");
  var instanceObj=sys.instances[id];
  if (!instanceObj){
  	//logger.append("starting making new planet");
    instanceObj=new instances.Instance(id,sys,name,machine,active,checktime,downtime,duration);
    sys.addInstance(instanceObj);
  }else{
  	
    var changed=set(instanceObj,'name',name)
      || set(instanceObj,'active',active)
      || set(instanceObj,'checktime',checktime)
      || set(instanceObj,'downtime',downtime)
      || set(instanceObj,'duration',duration);
    if(changed){
      //logger.append("before refresh");
      instanceObj.refreshValue(id,sys,name,machine,active,checktime,downtime,duration);
    }
    if (changed && instanceObj.rendered){
      instanceObj.rendered=false;
      
    }
  }
}

function AppendTD()
{
    var td = document.createElement("td");
    td.className='';
    td.setAttribute("height", "24px");
    return td;
}

/**
helper method for changing a property, and returning true if the value changed
useful for intelligently marking changes as dirty
*/
function set(obj,key,val){
	
  var changed=false;
  if (obj){
    var oldval=obj[key];
    if (oldval!=val){
      obj[key]=val;
      changed=true;
    }
  }
  return changed;
}
