#!/usr/bin/python
# Simple python tools to check whether squid is active or not
# Author: Liang Dong Oct 29 2008
# 
"""
Usage:
   ./SquidCheck.py 
"""
import sys
import re
import urllib
import getopt
import threading
import time
import os
import xml.dom.minidom
import traceback
class SquidChecker(threading.Thread):
	"SquidChecker for web "

	def __init__(self):
		self.appdir = os.getenv('APP_DIR')
		self.pattern = re.compile('time')
		self.ptime = re.compile(r'<strong>(?P<time>.*at.*)<\/strong>',re.VERBOSE)
		self.outxml = '<?xml version="1.0" ?>'
		self.site_name_list = []
		self.site_url_list = []
		self.menuurl="http://frontier.cern.ch/squidstats/menucms.html"
		self.url_pre="http://frontier.cern.ch/squidstats/"
#		print len(self.site_name_list),len(self.site_url_list)
#		for i in range(len(self.site_name_list)):
#			print self.site_name_list[i], self.site_url_list[i]
		threading.Thread.__init__(self)
		
#	def getUrl(self,site):
#		return '%s%s%s'%('http://frontier.cern.ch/squidstats/mrtgcms/',site,'/proxy-obj.html')
	def getSiteList(self):
		self.site_name_list = []
                self.site_url_list = []
                try:
                        data = urllib.urlopen(self.menuurl).read()
                except URLError, e:
                        if hasattr(e, 'reason'):
                                print 'We failed to reach a SAMDB server.'
                                print 'Reason: ', e.reason
                        elif hasattr(e, 'code'):
                                print 'The SAMDB server couldn\'t fulfill the request.'
                                print 'Error code: ', e.code
                        raise Exception("urlopen error")
		if data == None: raise Exception("read empty error")
		try:
			dom = xml.dom.minidom.parseString(data)

			table = dom.getElementsByTagName('table')[0]
			elements = table.childNodes
		except:
			raise Exception("dom format error")
		for element in elements:
			if element.hasChildNodes():
				if len(element.childNodes)==5:
					site = element.childNodes[1].firstChild.data
					urls = element.childNodes[3].getElementsByTagName('a')
					link = urls[2].getAttribute('href')
					self.site_name_list.append(site)
					self.site_url_list.append("http://frontier.cern.ch/squidstats/%s"%link)
					#print "http://frontier.cern.ch/squidstats/%s"%link
					#print urls[2].toxml()
					#print site
					#for url in urls:
					#	print url.toxml()
					#print item.toxml()
		for i in range(len(self.site_name_list)):
			print self.site_name_list[i], self.site_url_list[i]

	def check(self,site_url):
		url = site_url
		try:
			data = urllib.urlopen(url).read()
		except URLError, e:
			if hasattr(e, 'reason'):
	                        print 'We failed to reach a SAMDB server.'
        	                print 'Reason: ', e.reason
	                elif hasattr(e, 'code'):
	                        print 'The SAMDB server couldn\'t fulfill the request.'
	                        print 'Error code: ', e.code
	                raise Exception("urlopen error")
		sign=  self.pattern.search(data)
		site_name = self.site_name_list[self.site_url_list.index(url)]
		if not sign:
			times = self.ptime.findall(data)
			if times != []:
				time = times[0]
			else: time =0
			return site_name,time
		else: return None
	def run(self):
		while 1:
			try:
				self.getSiteList()
				context  = ""
				context  +="<squid> \n"
				for url in self.site_url_list:
					results =  self.check(url) 
					if results != None:
						context += '\t<site name="%s" link="%s" time="%s"></site>\n'% (results[0],url,results[1])
				context +="</squid>"
				self.outXML(context)
			except:
				print "Failed"
				print traceback.print_exc()
			time.sleep(10*60)
	def outXML(self,context):
		filename = os.path.join(self.appdir,'squid.xml')
		self.outxml = '<?xml version="1.0" ?>\n%s'%context
		output = open(filename,'w')
		output.write(self.outxml)
		output.close()
		


if __name__ == '__main__':
	thread = SquidChecker()
	thread.start()
