#!/usr/local/bin/bash
#
# Copy today's  log to docms11.cern.ch machine
#    if it is the first time today, copy yesterday's also
#
# Author: Liang dong   
# Thanks: Lee 
# Usage: ./copy_from_afs.sh
#
echo "#####"
echo `date +%Y-%m-%d-%H:%M:%S`
echo "#####"

today=`date +%Y%m%d`
hour="`date +%H`"
yesterday="`date -d 'yesterday'  +%Y%m%d`"
AFSdir=/afs/cern.ch/cms/cmsweb/log-archive
Localdir=/home/liangd/logfiles/cmsweb

#sleep 540
## access_log_20090301
for file in $(find  ${AFSdir}/vocms42/ -cmin -90 -iregex '.*\.zip$' )
do
    rsync -av  $file ${Localdir}/cmsweb1/`ls $file  | awk -F/ '{ print $8 }'`
    unzip -d ${Localdir}/cmsweb1 -uo  ${Localdir}/cmsweb1/`ls $file  | awk -F/ '{ print $8 }'`
done
for file in $(find  ${AFSdir}/vocms43/ -cmin -90 -iregex '.*\.zip$' )
do
    rsync -av  $file ${Localdir}/cmsweb2/`ls $file  | awk -F/ '{ print $8 }'`
    unzip -d ${Localdir}/cmsweb2 -uo  ${Localdir}/cmsweb2/`ls $file  | awk -F/ '{ print $8 }'`
done
# find  ${AFSdir}/vocms42/ -cmin -90 -iregex '.*\.zip$' 
#rsync -av  ${AFSdir}/vocms42/ ${Localdir}/cmsweb1
#rsync -av  ${AFSdir}/vocms43/ ${Localdir}/cmsweb2
# only unzip the new one.
#  find /data/dbs_logs/cmsweb/cmsweb1/ -name '*.zip'  -exec du {} \;

#find  ${Localdir}/cmsweb1 -name 'access*.zip'  -exec  unzip -d ${Localdir}/cmsweb1 -uo {} \;
#find  ${Localdir}/cmsweb2 -name 'access*.zip'  -exec  unzip -d ${Localdir}/cmsweb2 -uo {} \;





ARRAY=( 'phedexweb' 'phedexdatasvc' 'overview' 'sitedb' 'conddb' 'prodmon' 't0mon' 'base' 'discovery' 'crabconf' 'filemover' 'dqm' )
ELEMENTS=${#ARRAY[@]}



if [ "$hour" = 00 ] || [ "$hour" = 01 ]
then
	/usr/bin/python ${Localdir}/reform_split_cmsweb_log.py --input=${Localdir}/cmsweb1/access_log_${yesterday}
	/usr/bin/python ${Localdir}/reform_split_cmsweb_log.py --input=${Localdir}/cmsweb2/access_log_${yesterday}

	sort -m -t " " -k 1 -o ${Localdir}/access_log_${yesterday}.rfm  ${Localdir}/cmsweb1/access_log_${yesterday}.rfm ${Localdir}/cmsweb2/access_log_${yesterday}.rfm
	
        for (( i=0; i<${ELEMENTS}; i++ )); do
		sort -m -t " " -k 1 -o ${Localdir}/subservices/${ARRAY[i]}/access_log_${yesterday}.rfm  ${Localdir}/cmsweb1/subservices/${ARRAY[i]}/access_log_${yesterday}.rfm  ${Localdir}/cmsweb2/subservices/${ARRAY[i]}/access_log_${yesterday}.rfm
	done
else
## reform the log
/usr/bin/python ${Localdir}/reform_split_cmsweb_log.py --input=${Localdir}/cmsweb1/access_log_${today} 
/usr/bin/python ${Localdir}/reform_split_cmsweb_log.py --input=${Localdir}/cmsweb2/access_log_${today}
# merge them
sort -m -t " " -k 1 -o ${Localdir}/access_log_${today}.rfm ${Localdir}/cmsweb1/access_log_${today}.rfm ${Localdir}/cmsweb2/access_log_${today}.rfm
for (( i=0; i<${ELEMENTS}; i++ )); do
	sort -m -t " " -k 1 -o ${Localdir}/subservices/${ARRAY[i]}/access_log_${today}.rfm  ${Localdir}/cmsweb1/subservices/${ARRAY[i]}/access_log_${today}.rfm  ${Localdir}/cmsweb2/subservices/${ARRAY[i]}/access_log_${today}.rfm
done

fi

exit
