#!/bin/sh
#
# description: starts dbsfrontier monitor on  vocmsvm01/vocmsvm02 /home/dbfrontier/apps/Monitor/Apps
# $Id: dbsfrontier-monitor.sh,v 1.1 2009/04/08 14:21:33 dong Exp $
. /etc/init.d/functions
APP_DIR=/home/dbfrontier/apps/Monitor/Apps
export APP_DIR


status()
{
    # don't use $CATALINA_PID because the file gets copied
    #  to backup server where it doesn't make sense
    if su dbfrontier -c "killall -q -0 python"; then
	echo running
    else
	echo stopped
	return 1
    fi
}

start()
{
    case "`cl_status rscstatus`" in
	transition|active) ;;
	*)  echo "This can only be started on the ACTIVE server" >&2
	    exit 1
	    ;;
    esac
    if status >/dev/null; then
	echo "Already running"
	exit
    fi
    su dbfrontier -c "$APP_DIR/dbsfrontier_monitor start > /dev/null 2>&1 &"
}

stop()
{
    su dbfrontier -c "$APP_DIR/dbsfrontier_monitor stop > /dev/null 2>&1 &"
    N=0
    while [ $N -lt 3 ] && status >/dev/null; do
	# wait up to 3 seconds for it to exit gracefully
	sleep 1
	let N+=1
    done
    if status >/dev/null; then
	su dbfrontier -c "killall -q $APP_DIR/dbsfrontier_monitor"
    fi
}

case "$1" in
    start)
        start
        ;;
    stop)
        stop
        ;;
    status)
	status
        ;;
    restart|reload)
        ;;
    condrestart)
        ;;
    *)
        echo $"Usage: $0 {start|stop|status|restart}"
        exit 1
esac
