#!/usr/bin/python
import os,threading
from getCICFeed import GetCICFeed
from getOIM import GetOIM
from ical import Ical
from samdb_dict import SiteDB_dict
from rssParser import RssParser
from osgParser import OSGParser
import traceback
import time
class DowntimeFeed(threading.Thread):
        def __init__(self):
                self.appdir = os.getenv('APP_DIR')
                self.sitedb = SiteDB_dict()
                self.feedname = "CMS Downtime Notification"
                threading.Thread.__init__(self)

        def run(self):
		while 1:
	                ical_file = os.path.join(self.appdir,"Monit/cmsdowntime_All.ics")
	                ical_t0_t1_file = os.path.join(self.appdir,"Monit/cmsdowntime_Tier1.ics")
	                ical_t2_file = os.path.join(self.appdir,"Monit/cmsdowntime_Tier2.ics")
	                ical_t3_file = os.path.join(self.appdir,"Monit/cmsdowntime_Tier3.ics")

	                ical = Ical(ical_file)
	                ical_t0_t1 = Ical(ical_t0_t1_file)
	                ical_t2 = Ical(ical_t2_file)
	                ical_t3 = Ical(ical_t3_file)
	                self.sitedb.fill_dict(self.appdir)
			try:
				rss_feed = os.path.join(self.appdir,'Monit/cic.rss')
				oim_xml = os.path.join(self.appdir,'Monit/oim.xml')

		                getfeed = GetCICFeed()
		                feedurl = getfeed.feeddata(self.feedname)
		                feed_body = getfeed.links(feedurl)
		                getfeed.writedown(rss_feed)
				oim = GetOIM()
				oim_data = oim.getdata()
				oim.writedown(oim_xml)
			except Exception:
				print "open failed try to switch to the local file"
		                try:
					feed_file = open(rss_feed)
					oim_file = open(oim_xml)
					try:
						feed_body = feed_file.read()
						oim_data = oim_file.read()
					finally:
						feed_file.close()
						oim_file.close()
				except IOError:
					print "IO Error "
			try:
				feed_body = feed_body.encode('utf-8')
				oim_data = oim_data.encode('utf-8')
		                feedparse=RssParser(feed_body,self.appdir)
				osgparser = OSGParser(oim_data)

#               outfile = os.path.join(self.appdir,"Monit/nodelist")
#               file = open(outfile,'w')

		                feedparse.parser(self.sitedb,ical,ical_t0_t1,ical_t2,ical_t3)#,file)
	                	feedparse.output()
				osgparser.parser(self.sitedb,ical,ical_t0_t1,ical_t2,ical_t3)
#               file.close()
		                ical.publish()
		                ical_t0_t1.publish()
		                ical_t2.publish()
		                ical_t3.publish()
	                except Exception:
				print "Failed "
		                print traceback.print_exc()
		                print "end of Failed info"
			time.sleep(15*60)

#               ical.listURI()


if __name__ == "__main__":
        thread = DowntimeFeed()
	thread.start()
