#!/usr/bin/python
import re
import string
import sys
import httplib
import urllib2
from xml.dom import minidom
import os,threading,time





class SiteDB_dict:
	def __init__(self):
		self.name_dict={}
		self.ce_dict={}
		self.se_dict={}
	def fill_dict(self,appdir):
		filename1 = os.path.join(appdir,'Monit/name_convert.xml') 
		filename2 = os.path.join(appdir,'Monit/ce_convert.xml')
		filename3 = os.path.join(appdir,'Monit/se_convert.xml')
		name_file = open(filename1,'r') 
		ce_file = open(filename2,'r')
		se_file = open(filename3,'r')
		name_convert_xml=name_file.read()
		ce_convert_xml=ce_file.read()
		se_convert_xml=se_file.read()
		self.name_dict=self.parseoutput(name_convert_xml,True)
		self.ce_dict=self.parseoutput(ce_convert_xml)
		self.se_dict=self.parseoutput(se_convert_xml)
	def parseoutput(self,data, reverse=False):	
		"""XML parser for sitedb report"""
		dom  = minidom.parseString(data)
		datalist = {}
		nodes = dom.getElementsByTagName('item')
	
		for node in nodes:
#			print "each site"
#			for child in node.childNodes:
#				print "each node"
#				print child
			if reverse:
				keynode = node.childNodes[3]
				valnode = node.childNodes[1]
			else:
				keynode = node.childNodes[1]
				valnode = node.childNodes[3]
#			print valnode
			keydata = keynode.firstChild.data.lower()
			valdata = valnode.firstChild.data
				
			datalist[keydata]=valdata
		return datalist	
	def name_convert(self,sam_name):
#		print sam_name	
#		print len(name_dict)
		if self.name_dict.has_key(sam_name):
#		print sam_name +'='+name_dict[sam_name]
			return self.name_dict[sam_name]
		else: return None
	def element_exists(self,ele):
		if self.ce_dict.has_key(ele):
			return True
		elif self.se_dict.has_key(ele):
			return True
		else: return False

class GetFeed:

	def __init__(self):
		self.data = []
		feedname = "CMS Downtime Notification"
		url="http://cic.gridops.org/downtime_rss.php?id_sub=1641"
		self.feedinfo = {feedname:url}

	def feeddata (self, feedname):
        	feedaddress = self.feedinfo[feedname]
	        return feedaddress

	def links (self, address):
        	file_request = urllib2.Request(address)
	        file_opener = urllib2.build_opener()
        	file_open = file_opener.open(file_request)
#        for item in dir(file_open):
#            print item
#            print dir(getattr(file_open,item))
#        message = file_open.info()
#        print message
	        file_feed = file_open.read()
#        print dir(file_feed)

	        return file_feed
import sys
from xml.dom.ext.reader import Sax2
reader = Sax2.Reader()
from xml.dom.ext import PrettyPrint

from datetime import datetime, date, time
import time
#


class RssParser:
	def __init__(self,feed,appdir):
		self.feed = feed
		self.feeddom = reader.fromString(feed)
		self.appdir=appdir
		self.todaylist = []
	def output(self):
	        outputfile = os.path.join(self.appdir,'Monit/cmsdowntime.rss')
	        file_output= open(outputfile,'w')
	        PrettyPrint(self.feeddom,file_output)
	        file_output.close()
	def addTodayEvent(self,event):
		self.todayList.append(event)
	def cleanTodayList(self):
		self.todayList=[]
	def parser(self,sitedb,ical,ical_t0_t1,ical_t2,ical_t3):
		for node in self.feeddom.getElementsByTagName('item'):
			self.parseItem(node,sitedb,ical,ical_t0_t1,ical_t2,ical_t3)
	def deleteItem(self,node):
	    	node.parentNode.removeChild(node)
	def parseItem(self,node,sitedb,ical,ical_t0_t1,ical_t2,ical_t3):
#	parse ce/se name
		element_list = node.getElementsByTagName('downtime:node')
	        confirm = False
		if element_list.length != 0:
			for element in element_list:
				if element.hasChildNodes():
					site_node = element.firstChild
#			if site_node.nodeType == site_node.TEXT_NODE:
    					element_name = site_node.data
		    			element_name_lower = element_name.lower()      
#			cut off the name suffix _
			    		ele = element_name_lower.split('_')[0]			
				    	if sitedb.element_exists(ele):
					    	confirm = True
#	parse SiteName
	    	site=node.getElementsByTagName('downtime:site')[0].firstChild
	    	sam_name=site.data
	    	sam_name_lower=sam_name.lower()
#	print sam_name_lower
	    	cms_name=sitedb.name_convert(sam_name_lower)
#	print cms_name
		if cms_name == None: 
#		print "deleteItem"
			self.deleteItem(node)
    			return False
	    	else:
    			site.deleteData(0,len(sam_name))
	    		site.appendData(cms_name)
#	parse Title
        		title = node.getElementsByTagName('title')[0].firstChild
		        title_origin = title.data
	        	title_pics = title_origin.split(' ')
	        	title_type = title_pics[0]
	        	if title_type == 'ANNOUNCEMENT':
	    	    		title_pics[2] = cms_name + '/'
	        		title_new = " ".join(title_pics)
	        	elif title_type == 'START' or title_type == 'END':
	        		title_pics[2] = cms_name + '/'
	        		title_new = " ".join(title_pics)
	        	else: return False
	        	if not confirm: title_new= ' # ' + title_new
	        	title.deleteData(0,len(title_origin))
	        	title.appendData(title_new)
	        	if title_type == 'ANNOUNCEMENT':
	        		title_new=" ".join(title_pics[2:])
	        		if not confirm: title_new= ' # ' + title_new
	    		#       parse Ical feed
	    		#       URI,dtstart,dtend,dtstamp,summary,description
	        		URI=node.getElementsByTagName('link')[0].firstChild.data
	        		start=node.getElementsByTagName('downtime:start')[0].firstChild.data
	        		start=time.strptime(start,"%d-%m-%Y %H:%M")
	        		end=node.getElementsByTagName('downtime:end')[0].firstChild.data
	        		end=time.strptime(end,"%d-%m-%Y %H:%M")
	        		stamp=node.getElementsByTagName('pubDate')[0].firstChild.data
	        		stamp=time.strptime(str(stamp),"%a, %d %b %Y %H:%M:%S %Z")
	        		summary=title_new
	        		description=node.getElementsByTagName('description')[0].firstChild.data
				new_event = Event(URI,start,end,stamp,summary,description)
	        		ical.addEvent(new_event)
				if cms_name[0:2] == 'T3': 
					ical_t3.addEvent(new_event)
				elif cms_name[0:2] == 'T2':
					ical_t2.addEvent(new_event)
				else:
					ical_t0_t1.addEvent(new_event)
			if title_type == 'START':
				title_new=" ".join(title_pics[2:])
				if not confirm: title_new= ' # ' + title_new
				URI=node.getElementsByTagName('link')[0].firstChild.data
				start=node.getElementsByTagName('downtime:start')[0].firstChild.data
				start=time.strptime(start,"%d-%m-%Y %H:%M")
#				today = datetime.today()
#				startdate = date(start[0],start[1],start[2])
#				if today != startdate: pass
#				else:
				end=node.getElementsByTagName('downtime:end')[0].firstChild.data
				end=time.strptime(end,"%d-%m-%Y %H:%M")
				stamp=node.getElementsByTagName('pubDate')[0].firstChild.data
				stamp=time.strptime(str(stamp),"%a, %d %b %Y %H:%M:%S %Z")
				summary=title_new
				description=node.getElementsByTagName('description')[0].firstChild.data
				new_event = Event(URI,start,end,stamp,summary,description)
				if ical.hasEvent(new_event): pass
				else:
					ical.addEvent(new_event)
					if cms_name[0:2] == 'T3':
						ical_t3.addEvent(new_event)
					elif cms_name[0:2] == 'T2':
						ical_t2.addEvent(new_event)
					else:
						ical_t0_t1.addEvent(new_event)

	        	return True

class Event:
	def __init__(self,URI,dtstart,dtend,dtstamp,summary,description):
		self.URI = URI
		self.dtstart = dtstart
		self.dtend = dtend
		self.dtstamp = dtstamp
		self.summary = summary
		self.description = description
	
class Ical:
	def __init__(self,filename):
	        self.filename=filename
		name = os.path.split(filename)[1]
		name = name.split('.')[0]
		name = name.split('downtime')[1]
		self.name = name
	    	self.output=None
		self.eventlist = []
#   write the head for ical feed and open file
	def createIcalHead(self):
	   	self.output = open(self.filename,'w')
	    	begin="VCALENDAR"
	    	self.output.write("BEGIN:%s\n"%begin)
	    	version="2.0"
	    	self.output.write("VERSION:%s\n"%version)
#       X-WR-CALNAME
	    	calname="Ical for cms %s sites downtime"  % self.name
	        self.output.write("X-WR-CALNAME:%s\n"%calname)
	        prodid="-//Generated by CMS FacOps //-"
	        self.output.write("PRODID:%s\n"%prodid)
        	calscale="GREGORIAN"
	        self.output.write("CALSCALE:%s\n"%calscale)
        	method="PUBLISH"
	        self.output.write("METHOD:%s\n"%method)
        def addEvent(self,event):
		self.eventlist.append(event)
	def hasEvent(self,event):
		for e in self.eventlist:
			if self.compareEvent(e,event):
				return True
			else: return False
	def compareEvent(self,e1,e2):
		if e1.URI == e2.URI: return True
		else: return False

#   write the end of ical feed also close file        
	def createIcalEnd(self):
	        end="VCALENDAR"
        	self.output.write("END:%s\n"%end)
	        self.output.close()
	def convertTime(self,dt):
	        dt2 = datetime(*dt[0:6])
	        return dt2.strftime("%Y%m%dT%H%M%SZ")
	def publish(self):
		for e in self.eventlist:
			self.publishEvent(e)	
#   print a event out	
	def publishEvent(self,event):
		
		begin="VEVENT"
		self.output.write("BEGIN:%s\n"%begin)
#       URL;VALUE=URI
		uri="https://goc.gridops.org/downtime?id="
		self.output.write("URL:%s\n"%event.URI)

		if event.dtstart == None: dtstart="20090608T063000Z"
		else: dtstart = self.convertTime(event.dtstart)
		self.output.write("DTSTART:%s\n"%dtstart)

		if event.dtend == None: dtend="20090612T153000Z"
		else: dtend = self.convertTime(event.dtend)
		self.output.write("DTEND:%s\n"%dtend)

		if event.dtstamp == None: dtstamp="20090612T153000Z"
		else: dtstamp = self.convertTime(event.dtstamp)
		self.output.write("DTSTAMP:%s\n"%dtstamp)

		if event.summary == None: summary=""
		self.output.write("SUMMARY:%s\n"%event.summary)

		if event.description == None: description=""
		#description.replace("\n"," ")
		description_trip=" ".join(event.description.splitlines())
		self.output.write("DESCRIPTION:%s\n"%description_trip)

		end="VEVENT"
		self.output.write("END:%s\n"%end)

#   create a event on ical feed        
#	def createEvent(self,URI,dtstart,dtend,dtstamp,summary,description):
#	        begin="VEVENT"
#	        self.output.write("BEGIN:%s\n"%begin)
#       URL;VALUE=URI
#	        uri="https://goc.gridops.org/downtime?id="
#	        self.output.write("URL;VALUE=URI:%s\n"%URI)
#	        if dtstart == None: dtstart="20090608T063000Z"
#	        else: dtstart = self.convertTime(dtstart)
#	        self.output.write("DTSTART:%s\n"%dtstart)
#	        if dtend == None: dtend="20090612T153000Z"
#	        else: dtend = self.convertTime(dtend)
#	        self.output.write("DTEND:%s\n"%dtend)
#	        if dtstamp == None: dtstamp="20090612T153000Z"
#	        else: dtstamp = self.convertTime(dtstamp)
#	        self.output.write("DTSTAMP:%s\n"%dtstamp)
#	        if summary == None: summary=""
#	        self.output.write("SUMMARY:%s\n"%summary)
#		if description == None: description=""
	#description.replace("\n"," ")
#		description_trip=" ".join(description.splitlines())
#	        self.output.write("DESCRIPTION:%s\n"%description_trip)
#	        end="VEVENT"
#	        self.output.write("END:%s\n"%end)
		
def bodyfn(feedname):
	getfeed = GetFeed()
	feedurl = getfeed.feeddata(feedname)
	body = getfeed.links(feedurl)
	return body


	
class DowntimeFeed(threading.Thread):
	def __init__(self):
		self.appdir = os.getenv('APP_DIR')
		self.sitedb = SiteDB_dict()
		self.feedname = "CMS Downtime Notification"
		threading.Thread.__init__(self)
	def feedbody(self,feedname):
		getfeed = GetFeed()
		feedurl = getfeed.feeddata(feedname)
		body = getfeed.links(feedurl)
		return body
	def run(self):
		while 1:
			self.sitedb.fill_dict(self.appdir)
			feed = self.feedbody(self.feedname)
			feedparse=RssParser(feed,self.appdir)

			ical_file = os.path.join(self.appdir,"Monit/cmsdowntime.ics")
			ical_t0_t1_file = os.path.join(self.appdir,"Monit/cmsdowntime_t0_t1.ics")
			ical_t2_file = os.path.join(self.appdir,"Monit/cmsdowntime_t2.ics")
			ical_t3_file = os.path.join(self.appdir,"Monit/cmsdowntime_t3.ics")

			ical = Ical(ical_file)
			ical_t0_t1 = Ical(ical_t0_t1_file)
			ical_t2 = Ical(ical_t2_file)
			ical_t3 = Ical(ical_t3_file)

			ical.createIcalHead()
			ical_t0_t1.createIcalHead()
			ical_t2.createIcalHead()
			ical_t3.createIcalHead()

			feedparse.parser(self.sitedb,ical,ical_t0_t1,ical_t2,ical_t3)

			ical.publish()
			ical_t0_t1.publish()
			ical_t2.publish()
			ical_t3.publish()

			ical.createIcalEnd()
			ical_t0_t1.createIcalEnd()
			ical_t2.createIcalEnd()
			ical_t3.createIcalEnd()

			feedparse.output()
			time.sleep(15*60)



if __name__ == "__main__":
	thread = DowntimeFeed()
	thread.start()
