import httplib
import urllib
import urllib2
from urllib2 import Request, urlopen, URLError
import types
import time
import os
import sys
from xml.dom.minidom import parse, parseString
import string
import threading,time

class HTTPSClientAuthHandler(urllib2.HTTPSHandler):
    def __init__(self, key, cert):
        urllib2.HTTPSHandler.__init__(self)
        self.key = key
        self.cert = cert
    def https_open(self, req):
        return  self.do_open(self.getConnection, req)
    def getConnection(self, host, timeout=300):
        return httplib.HTTPSConnection(host, key_file=self.key,cert_file=self.cert)
def getKeyCert():
    # First presendence to HOST Certificate, RARE
    if os.environ.has_key('X509_HOST_CERT'):
        proxy = os.environ['X509_HOST_CERT']
        key = os.environ['X509_HOST_KEY']
    # Second preference to User Proxy, very common
    elif os.environ.has_key('X509_USER_PROXY'):
        proxy = os.environ['X509_USER_PROXY']
        key = proxy
    # Third preference to User Cert/Proxy combinition
    elif os.environ.has_key('X509_USER_CERT'):
        proxy = os.environ['X509_USER_CERT']
        key = os.environ['X509_USER_KEY']
    # Worst case, look for proxy at default location /tmp/x509up_u$uid
    else :
        uid = os.getuid()
        proxy = '/tmp/x509up_u'+str(uid)
        key = proxy
    #Set but not found
    if not os.path.exists(proxy) or not os.path.exists(key):
        raise Exception("Required Proxy for Secure Call not found for user '%s', please do init your proxy" %os.getlogin())
    # All looks OK, still doesn't gurantee proxy's validity etc.
    return key, proxy

def call(url, params=None, check=None):
	try:	
	    data   = urllib2.urlopen(url, urllib.urlencode(params, doseq=True))
	except URLError, e:
		if hasattr(e, 'reason'):
			print 'We failed to reach a server.'
			print 'Reason: ', e.reason
		elif hasattr(e, 'code'):
			print 'The server couldn\'t fulfill the request.'
			print 'Error code: ', e.code
	result = data.read()
	if  check and result.find('exception') != -1:
		raise Exception(result)
	return result
# test for output
def parseoutput(data, reverse=False):
    """
    XML parser for sitedb report
    """
    dom  = parseString(data)
    datalist = {}
    nodes = dom.getElementsByTagName('item')
	
    for node in nodes:
#		print "each site"
#		for child in node.childNodes:
#			print "each node"
#			print child
		if reverse:
			keynode = node.childNodes[3]
			valnode = node.childNodes[1]
		else:
			keynode = node.childNodes[1]
			valnode = node.childNodes[3]
#		print valnode
		keydata = keynode.firstChild.data.lower()
		valdata = valnode.firstChild.data
			
		datalist[keydata]=valdata
    return datalist
def parseouput_samdb(data):
	dom = parseString(data)
	#print dom.toxml()
	#print dir(dom)
	siteslist = {}
#	servicelist = []
	ROOT = dom.firstChild.lastChild
#	print ROOT.nodeName
	sites = ROOT.childNodes
#	print sites.length
#	print dir(ROOT)
	for site in sites:
#		print site.firstChild.toxml()
		print site.lastChild.firstChild.toxml()
		services = site.firstChild.childNodes
		servicelist = []
		for service in services:
#			if servicelist.count(service.nodeName) ==0:
#				servicelist.append(service.nodeName)
#				print service.nodeName	
#		print " ".join(servicelist)
#			print service.nodeName
			nodes = service.childNodes
			servicelist.append("%s:%s"%(service.nodeName,nodes.length))			
#			for node in nodes:
#				print node.firstChild.toxml()
#		print " ".join(servicelist)


#if __name__ == '__main__':
def download(appdir):
	samdb_url = "http://dashboard02.cern.ch/dashboard/request.py/checkhost"
#	samdb_url = "http://dashboard02.cern.ch/dashboard/request.py/checkhostss"
	filename4 = os.path.join(appdir,'Monit/node_convert.xml')
	params={}
#	node_convert_xml = call(samdb_url,params)
	try:
		f = urllib2.urlopen(samdb_url)

	except URLError, e:
		if hasattr(e, 'reason'):
			print 'We failed to reach a SAMDB server.'
			print 'Reason: ', e.reason
		elif hasattr(e, 'code'):
			print 'The SAMDB server couldn\'t fulfill the request.'
			print 'Error code: ', e.code
		raise Exception("urlopen error")

	node_convert_xml = f.read()
	if node_convert_xml == None : 
		raise Exception (' failed to read out from SAMDB ingore the writing to local files')
	try:	
		name_samdb = open(filename4,'w')
		try:
			name_samdb.write(node_convert_xml)
		finally:
			name_samdb.close()
	except IOError:
		raise Exception(' Failed to write local file')
	parseouput_samdb(node_convert_xml)

#	sitedb_url="https://cmsweb.cern.ch/sitedb/reports/showXMLReport/?reportid=cms_to_sam.ini"

	sitedb_url="https://cmsweb.cern.ch/sitedb/reports/showXMLReport/"
#	sitedb_url="https://cmsweb.cern.ch/sitedb/reports/showXMLReports/"
	params={'reportid':'cms_to_sam.ini'}
	try:
		#key,cert = getKeyCert()
		#opener = urllib2.build_opener(HTTPSClientAuthHandler(key,cert))
		#urllib2.install_opener(opener)
		name_convert_xml = call(sitedb_url, params)
	except:
		raise Exception("urlopen error")
 
	filename1 = os.path.join(appdir,'Monit/name_convert.xml')
	try:
		name_file = open(filename1,'w')
		try:
			name_file.write(name_convert_xml)
		finally:
			name_file.close()
	except IOError:
		raise Exception(' Failed to write local file')


	
class downloadSiteInfo(threading.Thread):
	def __init__(self):
		self.appdir = os.getenv('APP_DIR')
		threading.Thread.__init__(self)
	def run(self):
		while 1:
			try:
				download(self.appdir)
			except Exception:
				print "Error happened in download"
			time.sleep(24*60*60)

if __name__ == "__main__":
	appdir = os.getenv('APP_DIR')
	import traceback
	try:
		download(appdir)
	except Exception:
		print "Error happened in download"
		traceback.print_exc()
