#!/usr/bin/python
import os
from datetime import datetime, date, time

class Event:
        def __init__(self,URI,dtstart,dtend,dtstamp,summary,description,location,UID=None):

                self.URI = URI
                self.dtstart = dtstart
                self.dtend = dtend
                self.dtstamp = dtstamp
                self.summary = summary
                self.description = description
		self.location = location
		self.UID = URI

class Ical:
        def __init__(self,filename):
                self.filename=filename
                name = os.path.split(filename)[1]
                name = name.split('.')[0]
                name = name.split('downtime_')[1]
                self.name = name
                self.output=None
                self.eventlist = []
#   write the head for ical feed and open file
        def createIcalHead(self):
		try:

	                begin="VCALENDAR"
	                version="2.0"
	                calname="CMS %s sites downtime"  % self.name
	                prodid="-//Generated by CMS FacOps //-"
	                calscale="GREGORIAN"
	                method="PUBLISH"
	                self.output.write("BEGIN:%s\n"%begin)
	                self.output.write("VERSION:%s\n"%version)
#       X-WR-CALNAME
	                self.output.write("X-WR-CALNAME:%s\n"%calname)
	                self.output.write("PRODID:%s\n"%prodid)
	                self.output.write("CALSCALE:%s\n"%calscale)
	                self.output.write("METHOD:%s\n"%method)
		except IOError:
			raise Exception(' Failed to write local file')
        def addEvent(self,event):
                self.eventlist.append(event)
        def hasEvent(self,event):
                for e in self.eventlist:
                        if self.compareEvent(e,event):
                                return True
                return False
        def compareEvent(self,e1,e2):
                if e1.URI == e2.URI: return True
                else: return False

#   write the end of ical feed also close file        
        def createIcalEnd(self):
		try:
	                end="VCALENDAR"
	                self.output.write("END:%s\n"%end)

		except IOError:
			raise Exception(' Failed to write local file')
        def convertTime(self,dt):
                dt2 = datetime(*dt[0:6])
                return dt2.strftime("%Y%m%dT%H%M%SZ")
        def publish(self):
		try:
	                self.output = open(self.filename,'w')
			try:
		                self.createIcalHead()
		                for e in self.eventlist:
		                        self.publishEvent(e)
		                self.createIcalEnd()
			finally:
	                	self.output.close()
		except IOError:
			raise Exception(' Failed to write ics file and cleaned the file')			
		except Exception:
			self.output = open(self.filename,'w')
			self.output.write('')
			self.output.close()


#       only for test URI comparation
#       def listURI(self):
#               for e in self.eventlist:
#                       print e.URI
#   print a event out   
        def publishEvent(self,event):

                begin="VEVENT"
#       URL;VALUE=URI
                uri="https://goc.gridops.org/downtime?id="
                if event.dtstart == None: event.dtstart="20090608T063000Z"
                else: dtstart = self.convertTime(event.dtstart)
                if event.dtend == None: event.dtend="20090612T153000Z"
                else: dtend = self.convertTime(event.dtend)
                if event.dtstamp == None: event.dtstamp="20090612T153000Z"
                else: dtstamp = self.convertTime(event.dtstamp)
                if event.summary == None: event.summary=""
                if event.description == None: event.description=""
                #description.replace("\n"," ")
                description_trip=" ".join(event.description.splitlines())
		if event.location == None: event.location = ""
                end="VEVENT"
		try:
	                self.output.write("BEGIN:%s\n"%begin)
			self.output.write("UID:%s\n"%event.UID)
	                self.output.write("URL:%s\n"%event.URI)
	                self.output.write("DTSTART:%s\n"%dtstart)
        	        self.output.write("DTEND:%s\n"%dtend)
	                self.output.write("DTSTAMP:%s\n"%dtstamp)
	                self.output.write("SUMMARY:%s\n"%event.summary)
	                self.output.write("DESCRIPTION:%s\n"%description_trip.encode('utf-8'))
			self.output.write("LOCATION:%s\n"%event.location)
	                self.output.write("END:%s\n"%end)
		except IOError:
			print event.UID
			raise Exception(' Failed to write local file')

if __name__ == "__main__":
	import traceback
	appdir = os.getenv('APP_DIR')
	ical_file = os.path.join(appdir,"Monit/cmsdowntime_All.ics")
#        ical_t0_t1_file = os.path.join(self.appdir,"Monit/cmsdowntime_t0_t1.ics")
#        ical_t2_file = os.path.join(self.appdir,"Monit/cmsdowntime_t2.ics")
#	ical_t3_file = os.path.join(self.appdir,"Monit/cmsdowntime_t3.ics")
	try:
		file = open('Monit/cic.rss')
		try:
			feed_data = file.read()
		finally: file.close()
	except IOError:
		raise "read local feed data error"

	from rssParser import RssParser
	test_parser = RssParser(feed_data,appdir)

	from samdb_dict import SiteDB_dict
        dict = SiteDB_dict()
	try:
	        dict.fill_dict(appdir)
	except Exception:
		print "local file open or read error error"
		print traceback.print_exc()


	ical = Ical(ical_file)
#        ical_t0_t1 = Ical(ical_t0_t1_file)
#        ical_t2 = Ical(ical_t2_file)
#        ical_t3 = Ical(ical_t3_file)
	test_parser.parser(dict,ical)#,ical_t0_t1,ical_t2,ical_t3)#,file)
	try:
		ical.publish()
	except Exception:
		print "publish error"
		print traceback.print_exc()
#	ical_t0_t1.publish()
#        ical_t2.publish()
#        ical_t3.publish()
	


