#!/usr/bin/python
# -*- coding: utf-8 -*
# Python Standard library imports
import os.path
import time
from xml.dom.minidom import parse
import threading,os,stat

from FrontierActive_forweb_101 import FrontierActive
from DBSActive_forweb_101 import DBSActive
from SquidCheck_forweb_101 import SquidChecker
from getCMS_To_SAM import downloadSiteInfo
from downtimeFeed import DowntimeFeed
#
# The unique module to be imported use cherrypy
#
import cherrypy
from cherrypy.lib.static import serve_file
#
# needs an absolute path when dealing with static data
# considering APP_DIR can be not exist TODO expcetions
#
appdir = os.getenv('APP_DIR')
#
# A few HTML templates
#
_header =  """
        <html>
        <head>
                <title>Random notes</title>
        </head>
        <body>
        <div class="countainer">
"""
_footer = """
         </div>
        </body>
</html>
"""

FrontierXML = '%s<p>%s</p>%s'%(_header,"frontier",_footer) 
DBSXML      = '%s<p>%s</p>%s'%(_header,"dbs",_footer)
SquidXML    = '%s<p>%s</p>%s'%(_header,"squid",_footer)

#frontierLock = None
#dbsLock = None
#
# The main entry point of the Note application	
#
			
class MonitApp :
	"""
	The base apllication whitch will be hosted by cherrypy
	"""
	# Here we tell CherryPy we will enable the session
	# from this level of the tree of published objects
	# as well as its sub-levels
	def __init__(self,static_dirs):
		self.app_dir= static_dirs
	@cherrypy.expose
	def index(self):
#		name="instances.html"
		return serve_file(os.path.join(self.app_dir,"index.html"),content_type='text/html')
#		return [_header,os.path.join(self.app_dir,name),_footer]
	@cherrypy.expose
	def frontier(self):
		return serve_file(os.path.join(self.app_dir,"instances.html"),content_type='text/html')
#		return [_header,os.path.join(self.app_dir,name),_footer]
	@cherrypy.expose
	def dbs(self):
		return serve_file(os.path.join(self.app_dir,"instances2.html"),content_type='text/html')
	@cherrypy.expose
	def squid(self):
		return serve_file(os.path.join(self.app_dir,"MBoard.html"),content_type='text/html')
	@cherrypy.expose
	def overview(self):
		return serve_file(os.path.join(self.app_dir,"overview.html"),content_type='text/html')	
        @cherrypy.expose
        def feedhome(self):
                return serve_file(os.path.join(self.app_dir,"feedhome.html"),content_type='text/html')

	@cherrypy.expose
        def downtime_rssfeed(self):
                return serve_file(os.path.join(self.app_dir,"cmsdowntime.rss"),content_type='application/rss+xml')
	@cherrypy.expose
        def downtime_icsfeed(self):
                return serve_file(os.path.join(self.app_dir,"cmsdowntime_All.ics"),content_type='text/calendar')
	@cherrypy.expose
        def downtime_tier1(self):
                return serve_file(os.path.join(self.app_dir,"cmsdowntime_Tier1.ics"),content_type='text/calendar')
	@cherrypy.expose
        def downtime_tier2(self):
                return serve_file(os.path.join(self.app_dir,"cmsdowntime_Tier2.ics"),content_type='text/calendar')
	@cherrypy.expose
        def downtime_tier3(self):
                return serve_file(os.path.join(self.app_dir,"cmsdowntime_Tier3.ics"),content_type='text/calendar')

	@cherrypy.expose
	def css(self,name=None):
		css_dir = os.path.join(self.app_dir,"resources")
		return serve_file(os.path.join(css_dir,name),content_type='text/css')
	@cherrypy.expose
	def scripts(self,name=None):
		scripts_dir= os.path.join(self.app_dir,"resources")
		return serve_file(os.path.join(scripts_dir,name),content_type='application/x-javascript')
	@cherrypy.expose
	def x(self,name=None):
		xlib_dir= os.path.join(self.app_dir,"resources/x")
		return serve_file(os.path.join(xlib_dir,name),content_type='application/x-javascript')
	@cherrypy.expose
	def img(self,name=None):
		img_dir= os.path.join(self.app_dir,"resources/img")
		return serve_file(os.path.join(img_dir,name),content_type='image/x-png')
	@cherrypy.expose
	def awstats4dbs(self):
		return serve_file(os.path.join(self.app_dir,'awstats/dbs.html'),content_type='text/html')
	@cherrypy.expose
	def frontiert0(self):
		return serve_file(os.path.join(self.app_dir,'Frontier_t0/t0check'),content_type='text/html')
class getXMLdata:
	@cherrypy.expose
	def index(self,type=None):
		cherrypy.response.headers['Content-Type'] = 'text/xml'
		if type==None:
			return [_header,"None",_footer]
		elif type.lower() == "frontier":
			return FrontierXML
		elif type.lower() == "dbs":
			return DBSXML
		elif type.lower() == "squid":
			return SquidXML
		else :
			return [_header,"None",_footer]
class XMLProvider(threading.Thread):
	def __init__(self):
		self.FrontierXMLlastModify = 0;
		self.DBSXMLlastModify = 0;
		self.SquidXMLlastModify = 0;
		self.frontierxmlfile = os.path.join(appdir,"frontier.xml");
		self.dbsxmlfile = os.path.join(appdir,"dbs.xml");
		self.squidxmlfile = os.path.join(appdir,"squid.xml");
		threading.Thread.__init__(self)
	def getXML(self,xmlfile):
		xmldoc = parse(xmlfile)
		return xmldoc.toxml()
	def getlastModify(self,xmlfile):
		return os.stat(xmlfile)[stat.ST_MTIME]
	def run(self):
		global FrontierXML
		FrontierXML = self.getXML(self.frontierxmlfile)
		global DBSXML
		DBSXML =  self.getXML(self.dbsxmlfile)
		global SquidXML
		SquidXML = self.getXML(self.squidxmlfile)
		while 1:
			mtime = self.getlastModify(self.frontierxmlfile)
			if(self.FrontierXMLlastModify != mtime):
				self.FrontierXMLlastModify = mtime
				#frontierLock.acquire()
				FrontierXML = self.getXML(self.frontierxmlfile)
				#frontierLock.release()
			mtime = self.getlastModify(self.dbsxmlfile)
			if (self.DBSXMLlastModify != mtime):
				self.DBSXMLlastModify = mtime
				#dbsLock.acquire()
				DBSXML = self.getXML(self.dbsxmlfile)
				#dbsLock.release()
			mtime = self.getlastModify(self.squidxmlfile)
			if (self.SquidXMLlastModify != mtime):
				self.SquidXMLlastModify = mtime
				SquidXML = self.getXML(self.squidxmlfile)

			time.sleep(5*60)
				
if __name__ == '__main__'	:
	static_dirs = os.path.join(appdir,'Monit')
	# Define the global configuration settings of Cherrypy
	global_conf = {
		'global':{'engine.autoreload.on':False,
				'server.socket_host': 'localhost',
				'server.socket_port': 8020,}}
	application_conf = {
		'/':{'tools.staticdir.root' : static_dirs},
		'/resources':{'tools.staticdir.on' : True ,
			'tools.staticdir.dir' : 'resources'},
		'/resources/img':{'tools.staticdir.on' : True ,
			'tools.staticdir.dir' : 'resources/img'}	
		}
	# Update the global CherryPy configuration
	cherrypy.config.update(global_conf)
	# Create an instance of the application
	monit_app = MonitApp(static_dirs)
	monit_app.getXMLdata = getXMLdata()
	#
	#frontierLock = threading.Lock()
	#dbsLock = threading.Lock()
	xmlProvider = XMLProvider()
	xmlProvider.start()
	frontierThread = FrontierActive()
	frontierThread.start()
	dbsThread = DBSActive()
	dbsThread.start()
	squidThread = SquidChecker()
	squidThread.start()	
	download = downloadSiteInfo()
	download.start()
	downtimefeed = DowntimeFeed()
	downtimefeed.start()

	cherrypy.tree.mount(monit_app,'/',config = application_conf)
	# start the CherryPy HTTP server
	cherrypy.server.quickstart()
	# Start the CherryPy engine
	cherrypy.engine.start()
				 	
		
