#!/usr/bin/python
import os
from xml.dom.ext.reader import Sax2
reader = Sax2.Reader()
from xml.dom.ext import PrettyPrint
#from datetime import datetime
import time
#
from ical import Event

class OSGParser:
	def __init__(self,data):
		self.data = data
		self.doms =  reader.fromString(self.data)
	def output(self):
		pass
	def parser(self,sitedb,ical,ical_t0_t1=None,ical_t2=None,ical_t3=None):
		if len(self.doms.getElementsByTagName('Downtime')) >= 1:
#			print "downtime found "
			for node in self.doms.getElementsByTagName('Downtime'):
#				print "parse items"
				self.parseItem(node,sitedb,ical,ical_t0_t1,ical_t2,ical_t3)
	def parseItem(self,node,sitedb,ical,ical_t0_t1,ical_t2,ical_t3):
#       general check for all tags.

		tag_list = ('ID','GroupName','ResourceFQDN','StartTime','EndTime','Class','Severity','Description')
		for tag in tag_list:
			if node.getElementsByTagName(tag) == None or len(node.getElementsByTagName(tag)) == 0:
				print tag," not found"
				return False
			if node.getElementsByTagName(tag)[0].firstChild == None:
				print tag," empty tag"
				return False
#	       parse ce/se name
		element_list = node.getElementsByTagName('ResourceFQDN')
		confirm = False
#       	parse SiteName
		site=node.getElementsByTagName('GroupName')[0].firstChild
		sam_name=site.data
		sam_name_lower=sam_name.lower()
#		print sam_name_lower
#	       print sam_name_lower
		cms_name=sitedb.name_convert(sam_name_lower)
#		print cms_name
#	       location info
		location = ""
#	       nodes showing in location
		nodes_location = []

		if element_list.length != 0:
#               servicelist in samdb
			servicelist_samdb = sitedb.get_services(sam_name_lower)
#                       servicelist in rss feed
			servicelist = {}
			for element in element_list:
				if element.hasChildNodes():
					site_node = element.firstChild
#                       if site_node.nodeType == site_node.TEXT_NODE:
					element_name = site_node.data
					element_name_lower = element_name.lower()
					service = sitedb.search_node(element_name_lower,sam_name_lower)
					if service != None:
						if not servicelist.has_key(service):
							servicelist[service] = 1
						else:
							servicelist[service] = servicelist[service] + 1
#						add new node to nodes_location list
						if nodes_location.count(element_name_lower) == 0:
							nodes_location.append(element_name_lower)


#                       create location info
			for service in servicelist.keys():
				location = location + " %s: %d/%d,"%(service,servicelist[service],servicelist_samdb[service])
#                       for CE or SE if all in rss feed then will be a full downtime, confirm = True
				if service == 'ce' and servicelist[service] == servicelist_samdb[service] :
					confirm = True
				if service == 'srmv2' and servicelist[service] == servicelist_samdb[service] :
					confirm = True
#       print cms_name
		if cms_name == None:
#			print "not cms site"
			return False
		else:
#       Make Title 
#	END of T2_IN_TIFR/ UNSCHEDULED downtime [ 16-08-2009 14:55 to 17-08-2009 05:48 UTC ] 
#	16-08-2009 14:55
#	Sep 14, 2009 15:30:00 UTC
			severity = node.getElementsByTagName('Severity')[0].firstChild.data
			startf = node.getElementsByTagName('StartTime')[0].firstChild.data
			start = time.strptime(startf,"%b %d, %Y %H:%M:%S %Z")
			endf = node.getElementsByTagName('EndTime')[0].firstChild.data
			end = time.strptime(endf,"%b %d, %Y %H:%M:%S %Z")
			classes = node.getElementsByTagName('Class')[0].firstChild.data
			description = node.getElementsByTagName('Description')[-1].firstChild.data
			URI = node.getElementsByTagName('ID')[0].firstChild.data

			startf = startf.split('UTC')[0]
			endf = endf.split('UTC')[0]
			title = "%s/ %s downtime [ %sto %sUTC]"%(cms_name,classes,startf,endf)
			if not confirm: title = ' # ' + title
			summary = title + " " + severity
			URL = "http://myosg.grid.iu.edu/rgdowntime/xml?datasource=downtime&summary_attrs_showservice=on&summary_attrs_showrsvstatus=on&summary_attrs_showfqdn=on&gip_status_attrs_showtestresults=on&account_type=cumulative_hours&ce_account_type=gip_vo&se_account_type=vo_transfer_volume&start_type=7daysago&start_date=09%2F14%2F2009&end_type=now&end_date=09%2F14%2F2009&all_resources=on&gridtype=on&gridtype_1=on&service_central_value=0&service_hidden_value=0&vosup_3=on&voown=on&voown_3=on&active=on&active_value=1&disable_value=1&has_wlcg=on"
			LINK = " <a href=\"%s\">LINK</a>"%URL
			location = location + " " + " ".join(nodes_location)
			description = description + LINK
			stamp = start
#			print title
			new_event = Event(URI,start,end,stamp,summary,description,location)
			if ical.hasEvent(new_event):
				pass
			else:
				ical.addEvent(new_event)
				if cms_name[0:2] == 'T3' and ical_t3 != None:
					ical_t3.addEvent(new_event)
				elif cms_name[0:2] == 'T2' and ical_t2 != None:
					ical_t2.addEvent(new_event)
				elif ical_t0_t1 != None:
					ical_t0_t1.addEvent(new_event)
			return True
		

if __name__ == "__main__":
	import traceback
	appdir = os.getenv('APP_DIR')
	from getOIM import GetOIM
	oim = GetOIM()
	
#	files = "OIM.xml"
#	oim.writedown(files)
	from ical import Ical
	ical_file = os.path.join(appdir,"Monit/cmsdowntime_OSG.ics")
	ical = Ical(ical_file)
	from samdb_dict import SiteDB_dict
	dict = SiteDB_dict()
	try:
		data = oim.getdata()
		osgparser = OSGParser(data)
		dict.fill_dict(appdir)
		osgparser.parser(dict,ical)
		ical.publish()
	except Exception:
		print "Failed "
		print traceback.print_exc()

			

		
	
