#!/usr/bin/python
import os
from xml.dom import minidom

class SiteDB_dict:
        def __init__(self):
                self.name_dict={}
#                self.ce_dict={}
#                self.se_dict={}
		self.node_dict={}
        def fill_dict(self,appdir):
                filename1 = os.path.join(appdir,'Monit/name_convert.xml')
#                filename2 = os.path.join(appdir,'Monit/ce_convert.xml')
#                filename3 = os.path.join(appdir,'Monit/se_convert.xml')
		filename4 = os.path.join(appdir,'Monit/node_convert.xml')
		try:
	                name_file = open(filename1,'r')
		except:
			raise Exception("local file open error")
#                ce_file = open(filename2,'r')
#                se_file = open(filename3,'r')
		try:
			node_file = open(filename4,'r')
		except:
			raise Exception("local file open error")

                name_convert_xml=name_file.read()
		if name_convert_xml == None:
			raise Exception("local file read error")
#                ce_convert_xml=ce_file.read()
#                se_convert_xml=se_file.read()
		node_convert_xml= node_file.read()
		if node_convert_xml == None:
			raise Exception("local file read error")

                self.name_dict=self.parseoutput(name_convert_xml,True)
#                self.ce_dict=self.parseoutput(ce_convert_xml)
#                self.se_dict=self.parseoutput(se_convert_xml)
		self.node_dict=self.parseSamoutput(node_convert_xml)
	def parseSamoutput(self,data):
		"""XML parser for samdb info"""
		dom = minidom.parseString(data)
		datadict = {}
		ROOT = dom.firstChild.lastChild
		sites = ROOT.childNodes
		for site in sites:
			sitename = site.lastChild.firstChild.toxml().lower()
			services = site.firstChild.childNodes
#			add new site
			datadict[sitename]={}
        	        for service in services:
				servicelist = []
				nodes = service.childNodes
				servicename = service.nodeName.lower()
#				create new service
	                       	for node in nodes:
        	                       	node_name = node.firstChild.toxml().lower()
#					add node in service
					servicelist.append(node_name)
#				add service in site
				datadict[sitename][servicename]=servicelist

				
	
		return datadict
        def parseoutput(self,data, reverse=False):
                """XML parser for sitedb report"""
                dom  = minidom.parseString(data)
                datalist = {}
                nodes = dom.getElementsByTagName('item')

                for node in nodes:
#                       print "each site"
#                       for child in node.childNodes:
#                               print "each node"
#                               print child
                        if reverse:
                                keynode = node.childNodes[3]
                                valnode = node.childNodes[1]
                        else:
                                keynode = node.childNodes[1]
                                valnode = node.childNodes[3]
#                       print valnode
                        keydata = keynode.firstChild.data.lower()
                        valdata = valnode.firstChild.data
			if not datalist.has_key(keydata): datalist[keydata]=valdata

                return datalist
        def name_convert(self,sam_name):
#               print sam_name
#               print len(name_dict)
                if self.name_dict.has_key(sam_name):
#               print sam_name +'='+name_dict[sam_name]
                        return self.name_dict[sam_name]
                else: return None
	def has_site(self,site_name):
		return self.node_dict.has_key(site_name)
	def get_site(self,site_name):
		if self.has_site(site_name): 
			return self.node_dict[site_name]
		else: 
			return None
	def get_services(self,site_name):
		if self.has_site(site_name):
			servicelist={}
			for service in self.node_dict[site_name].keys():
				servicelist[service]=len(self.node_dict[site_name][service])
			return servicelist
		return None
	def search_node(self,node_name,site_name=None):
		if self.has_site(site_name):
			for service in self.node_dict[site_name].keys():
				if self.node_dict[site_name][service].count(node_name) != 0:
					return service
			return None
		return None
#        def element_exists(self,ele):
#                if self.ce_dict.has_key(ele):
#                        return True
#                elif self.se_dict.has_key(ele):
#                        return True
#                else: return False

if __name__ == "__main__":
        dict = SiteDB_dict()
        appdir = os.getenv('APP_DIR')
	import traceback
	try: 
	        dict.fill_dict(appdir)
	except Exception:
		print "local file open or read error error"
		print traceback.print_exc()
	for site in  dict.node_dict.keys():
		print site
		for service in dict.node_dict[site].keys():
			print service, ",".join (dict.node_dict[site][service])
	site_name="infn-cnaf"
	site_name1="infncnaf"
	print dict.get_site(site_name)
	print dict.get_site(site_name1)
	print dict.search_node('gridit-ce-001.cnaf.infn.it',site_name)
	print dict.search_node('node.cern.ch',site_name)
        print dict.search_node('gridit-ce-001.cnaf.infn.it',site_name1)
        print dict.search_node('node.cern.ch',site_name)
	print dict.search_node('gridit-ce-001.cnaf.infn.it')
	print dict.get_services(site_name)
	print dict.get_services(site_name1)

